$(function() {
	var _entries = $('span.menu-item');
	var i;

	var _src_open = $( '#js-menu-open' ).attr( 'src' );
	var _src_closed = $( '#js-menu-closed' ).attr( 'src' );

	var _nodes = {};
	var _status = {};
	var _prev_parent;

	for ( i = 0 ; i < _entries.length ; i ++ ) {
		var _e = $( _entries[ i ] );
		_e.attr( 'id' , 'menu-item-id-' + i );

		if ( _e.hasClass( 'menu-level-1' ) ) {
			_prev_parent = _e;

		} else {

			if ( ! _nodes[ _prev_parent.attr( 'id' ) ] ) {
				var _pe = _prev_parent.hasClass( 'open' );
				_nodes[ _prev_parent.attr( 'id' ) ] = [];
				_status[ _prev_parent.attr( 'id' ) ] = _pe;
				_prev_parent.css( 'background-image' , 'url(' + ( _pe ? _src_open : _src_closed ) + ')' );

				_prev_parent.click( function (e) {
					if ( ! $( e.target ).is( 'span' ) ) {
						return;
					}

					var _id = $(this).attr( 'id' );
					for ( var x in _nodes[ _id ] ) {
						if ( _status[ _id ] ) {
							_nodes[ _id ][ x ].hide('fast');
						} else {
							_nodes[ _id ][ x ].show('fast');
						}
					}
					_status[ _id ] = ! _status[ _id ];
					$(this).css( 'background-image' , 'url(' + ( _status[ _id ] ? _src_open : _src_closed ) + ')' );
				} );
			}

			_nodes[ _prev_parent.attr( 'id' ) ].push( _e );

			if ( _prev_parent.hasClass( 'closed' ) ) {
				_e.hide( );
			}

		}
	}
});